//+------------------------------------------------------------------+
//| ZZMatrica.mq4   07  2010                                    |
//+------------------------------------------------------------------+
#property copyright "nen"
#property link      "http://www.onix-trade.net/forum/index.php?showtopic=86495&view=findpost&p=391272"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Red

//---- input parameters
extern int          TF = 60;
extern int externalBar = 0; // 1 -       . 0 -          
extern int   ExtMaxBar = 1000; //    (0-)

//---- buffers
double zzh[];
double zzl[];

double lLast=0, hLast=0, hBar, lBar; 
datetime tLast, tiZZ;
int saveBars, saveBarsTF, currentBarsTF, limit, hl=0; 
int hi,li;
static int up=1, dn=-1;
/*
tLast -   ,       ,   ()  () ()
*/
//     " "
double save_lLast, save_hLast;
datetime save_tLast, save_tbar1, t_hi, t_li;
int save_hl;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ZIGZAG);
   SetIndexBuffer(0,zzh);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ZIGZAG);
   SetIndexBuffer(1,zzl);
   SetIndexEmptyValue(1,0.0);
//----
   if (externalBar<0) externalBar=0;
   if (externalBar>1) externalBar=1;
   if (ExtMaxBar<=0 || ExtMaxBar>iBars(NULL, TF)) ExtMaxBar=iBars(NULL, TF)-1;

   saveBars=0; saveBarsTF=0; currentBarsTF=0;
//   if (TF>1) 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   bool calculate; 

   if (Period()>TF) return (-1);

   if (iBars(NULL, TF)-currentBarsTF>1) {saveBarsTF=0;}
   currentBarsTF=iBars(NULL, TF);

   limit=Bars-saveBarsTF;
   calculate=false;

   if (limit>1)
     {
      calculate=true;
      hl=0;
      ArrayInitialize(zzh,0.0);
      ArrayInitialize(zzl,0.0);
     }
   else
     {
      if (lBar<=iLow(NULL, TF, 0) && hBar>=iHigh(NULL, TF, 0) && tiZZ==iTime(NULL, TF, 0)) return(0);
      else {calculate=true;}
     }

   if (calculate)
     {
      swing();
      saveBarsTF=Bars;
     }

   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  . .                                        |
//+------------------------------------------------------------------+
void swing()
  {
   int i, j, k, n, m, save1_hi, save1_li;

   if (limit>1)  //  
     {
      if (iBarShift(NULL, TF, Time[Bars-1], true)<ExtMaxBar) n=iBarShift(NULL, TF, Time[Bars-1], true);
      else n=ExtMaxBar;
      lLast=iLow(NULL, TF, n); hLast=iHigh(NULL, TF, n); tLast=iTime(NULL, TF, n);
      n--;
     }
   else  //   ,      (  )
     {
      n=iBarShift(NULL, TF, save_tbar1, false);
      lLast=save_lLast; hLast=save_hLast; tLast=save_tLast;
      hi=iBarShift(NULL, Period(), t_hi, false); li=iBarShift(NULL, Period(), t_li, true);
      hl=save_hl;
//      Print("n = ",n,"   hi = ",hi,"   li = ",li,"   hl = ",hl,"   TF = ",TF,"    ",Period(),"  = ",TimeToStr(save_tbar1,TIME_DATE|TIME_MINUTES));
      if (hi<li) m=hi; else m=li;
      for (i=m-1;i>=0;i--) {zzh[i]=0; zzl[i]=0;}
     }
//---
   for (i=n;i>=0;i--)
     {
      if (i==1)
        {
         zzl[1]=0; zzh[1]=0;
         zzl[0]=0; zzh[0]=0;
         //      " "
         save_lLast=lLast; save_hLast=hLast; save_tLast=tLast;
         t_hi=Time[hi]; t_li=Time[li];
         save_hl=hl;
         save_tbar1=iTime(NULL, TF, i);
        }

      if (lLast>iLow(NULL, TF, i) && hLast>=iHigh(NULL, TF, i))  //  Down
        {
         if (hl==dn) zzl[li]=0; 
         lLast=iLow(NULL, TF, i); hLast=iHigh(NULL, TF, i); tLast=iTime(NULL, TF, i);
         hl=dn; li=searchbarcur(Period(), dn); 
         zzl[li]=lLast;
        }
      else if (lLast<=iLow(NULL, TF, i) && hLast<iHigh(NULL, TF, i))  //  Up
        {
         if (hl==up) zzh[hi]=0; 
         lLast=iLow(NULL, TF, i); hLast=iHigh(NULL, TF, i); tLast=iTime(NULL, TF, i);
         hl=up; hi=searchbarcur(Period(), up); 
         zzh[hi]=hLast;
        }
      else if (lLast<=iLow(NULL, TF, i) && hLast>=iHigh(NULL, TF, i) && i>0) //   .       .
        {
         if (hl==0) continue;

         //---
         // ,       -   
         if (Period()<TF) k=_tf(Period(), true); else k=_tf(Period()-1, true);
         for (j=k;j>=0;j--)
           {
            hi=searchbarcur(_tf(j, false), up); 
            li=searchbarcur(_tf(j, false), dn);
            if (hi!=li)
              {
               //     
               if (hl==dn && hi<li) {hl=up; hi=searchbarcur(Period(), up); zzh[hi]=hLast;}
               if (hl==up && hi>li) {hl=dn; li=searchbarcur(Period(), dn); zzl[li]=lLast;}
               break;
              }
           }
         //---

         tLast=iTime(NULL, TF, i); lLast=iLow(NULL, TF, i); hLast=iHigh(NULL, TF, i);
         if (hl==dn) {hl=up; hi=searchbarcur(Period(), up); zzh[hi]=hLast;} // li=0;
         else if (hl==up) {hl=dn; li=searchbarcur(Period(), dn); zzl[li]=lLast;} // hi==0;
        }
      else if (lLast>iLow(NULL, TF, i) && hLast<iHigh(NULL, TF, i)) //    ()
        {
         if (hl==0) continue;
         save1_hi=hi; save1_li=li;
         lLast=iLow(NULL, TF, i); hLast=iHigh(NULL, TF, i); tLast=iTime(NULL, TF, i);

         //---
         //      . .
         // ,    -     
         if (Period()<TF) k=_tf(Period(), true); else k=_tf(Period()-1, true);
         for (j=k;j>=0;j--)
           {
            hi=searchbarcur(_tf(j, false), up); 
            li=searchbarcur(_tf(j, false), dn);
            if (hi!=li) break;
           }

         if (hi!=li)
           {
            if(hl==dn && li>hi) zzl[save1_li]=0;
            if(hl==up && li<hi) zzh[save1_hi]=0;
            if (li>hi) hl=up; else hl=dn;
           }
         else
           {
            if (externalBar==0)
              {
               if (hl==dn)
                 {
                  if ((hLast-zzl[save1_li])<(zzl[save1_li]-lLast)) {hl=dn;} else {zzl[save1_li]=0; hl=up;}
                 }
               else
                 {
                  if ((hLast-zzh[save1_hi])<(zzh[save1_hi]-lLast)) {zzh[save1_hi]=0; hl=dn;} else {hl=up;}
                 }
              }
            else if (externalBar==1)
              {
               if (hl==dn) {zzl[save1_li]=0; hl=up;}
               else {zzh[save1_hi]=0; hl=dn;}
              }
           }
         //      . .
         //---

         hi=searchbarcur(Period(), up); zzh[hi]=hLast;
         li=searchbarcur(Period(), dn); zzl[li]=lLast;
        }
      else
        {
         lLast=iLow(NULL, TF, i); hLast=iHigh(NULL, TF, i); tLast=iTime(NULL, TF, i);
        }

     }
//---

   lBar=iLow(NULL, TF, 0); hBar=iHigh(NULL, TF, 0); tiZZ=iTime(NULL, TF, 0); 
  }
//+------------------------------------------------------------------+
//|  . .                                         |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|     . .                       |
//+------------------------------------------------------------------+
int searchbarcur(int tf, int UpDn)
  {
   int i, j, tend;
   double wr;
   string stf;
   i=-1;
   j=iBarShift(NULL, tf, tLast, false); tend=tLast+TF*60;

   while (iTime(NULL, tf, j)<tLast && j>=0) j--;

   if (iTime(NULL, tf, j)<tend && j<iBars(NULL,tf) && j>=0)
     {
      if (UpDn==dn)
        {
         wr=1000000;
         while (iTime(NULL, tf, j)<tend && j>=0)
           {
            if (wr>iLow(NULL, tf, j)) {i=j; wr=iLow(NULL, tf, j); if (NormalizeDouble(wr-lLast,Digits)==0 || wr<lLast) return (i);}
//            if (wr>iLow(NULL, tf, j)) {i=j; wr=iLow(NULL, tf, j); if (wr<=lLast) return (i);}
            j--;
           }
        }
      else if (UpDn==up)
        {
         wr=0;
         while (iTime(NULL, tf, j)<tend && j>=0)
           {
            if (wr<iHigh(NULL, tf, j)) {i=j; wr=iHigh(NULL, tf, j); if (NormalizeDouble(wr-hLast,Digits)==0 || wr>hLast) return (i);}
//            if (wr<iHigh(NULL, tf, j)) {i=j; wr=iHigh(NULL, tf, j); if (wr>=hLast) return (i);}
            j--;
           }
        }
      return (i);
     }
   else
     {
      if (tf==Period())
        {
         switch (tf)
           {
            case 1:     {stf="M1";  break;}
            case 5:     {stf="M5";  break;}
            case 15:    {stf="M15"; break;}
            case 30:    {stf="M30"; break;}
            case 60:    {stf="H1";  break;}
            case 240:   {stf="H4";  break;}
            case 1440:  {stf="D1";  break;}
            case 10080: {stf="W1";  break;}
            case 43200: {stf="MN";}
           }

         j=iBarShift(NULL, tf, tLast, false);
         if (j<iBars(NULL,tf)) Print("  ",stf,"      ",TimeToStr(tLast,TIME_DATE|TIME_MINUTES),"    =",TF,"  "); 
        }
      return (-1);
     }

  }
//+------------------------------------------------------------------+
//|     . .                         |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|   . .                        |
//+------------------------------------------------------------------+
/*
y=true -  TF    
1     - 0
5     - 1
15    - 2
30    - 3
60    - 4
240   - 5
1440  - 6
10080 - 7
43200 - 8

y=false -       ( )
*/
int _tf (int tf, bool y)
  {
   if (y)
     {
      if (tf<5)          return (0);
      else if (tf<15)    return (1);
      else if (tf<30)    return (2);
      else if (tf<60)    return (3);
      else if (tf<240)   return (4);
      else if (tf<1440)  return (5);
      else if (tf<10080) return (6);
      else if (tf<43200) return (7);
      return (8);
     }
   else
     {
      if (tf==0)      return (PERIOD_M1);
      else if (tf==1) return (PERIOD_M5);
      else if (tf==2) return (PERIOD_M15);
      else if (tf==3) return (PERIOD_M30);
      else if (tf==4) return (PERIOD_H1);
      else if (tf==5) return (PERIOD_H4);
      else if (tf==6) return (PERIOD_D1);
      else if (tf==7) return (PERIOD_W1);
      else if (tf>=8) return (PERIOD_MN1);
      else if (tf<0)  return (-1);
     }
  }
//+------------------------------------------------------------------+
//|   . .                         |
//+------------------------------------------------------------------+

